stages:
  - production

image: docker:git

services:
  - docker:dind

variables:
  CERTS: ~/.docker

deploy-engrave:
  stage: production

  environment:
    name: engrave
    url: https://engrave.website

  before_script:

    # Docker TLS certificates
    - mkdir -p $CERTS
    - echo "$ENGRAVE_TLSCACERT" > $CERTS/ca.pem
    - echo "$ENGRAVE_TLSCERT" > $CERTS/cert.pem
    - echo "$ENGRAVE_TLSKEY" > $CERTS/key.pem

    # Login to gitlab docker registry
    - echo $CI_JOB_TOKEN | DOCKER_CERT_PATH=$CERTS docker -H $ENGRAVE_HOST --tlsverify login -u gitlab-ci-token registry.gitlab.com --password-stdin
    # Pull all necessary images before deploy
    - cat ./environments/engrave/docker-compose.engrave.yml | grep -oE 'image:([ a-zA-Z0-9\:\/\.-]*)' | sed "s~image:~~g" | while read -r image ; do DOCKER_CERT_PATH=$CERTS docker -H $ENGRAVE_HOST --tlsverify pull $image; done

  script:
    - DOCKER_CERT_PATH=$CERTS docker -H $ENGRAVE_HOST --tlsverify stack deploy --with-registry-auth -c ./environments/engrave/docker-compose.engrave.yml engrave

  after_script:
    - rm -fR $CERTS

  when: manual
  only:
    - master


deploy-dblog:
  stage: production

  environment:
    name: dblog
    url: https://dblog.pl

  before_script:

    # Docker TLS certificates
    - mkdir -p $CERTS
    - echo "$DBLOG_TLSCACERT" > $CERTS/ca.pem
    - echo "$DBLOG_TLSCERT" > $CERTS/cert.pem
    - echo "$DBLOG_TLSKEY" > $CERTS/key.pem

    # Login to gitlab docker registry
    - echo $CI_JOB_TOKEN | DOCKER_CERT_PATH=$CERTS docker -H $DBLOG_HOST --tlsverify login -u gitlab-ci-token registry.gitlab.com --password-stdin
    # Pull all necessary images before deploy
    - cat ./environments/dblog/docker-compose.dblog.yml | grep -oE 'image:([ a-zA-Z0-9\:\/\.-]*)' | sed "s~image:~~g" | while read -r image ; do DOCKER_CERT_PATH=$CERTS docker -H $DBLOG_HOST --tlsverify pull $image; done

  script:
    - DOCKER_CERT_PATH=$CERTS docker -H $DBLOG_HOST --tlsverify stack deploy --with-registry-auth -c ./environments/dblog/docker-compose.dblog.yml dblog

  after_script:
    - rm -fR $CERTS

  when: manual
  only:
    - master
